
#ifndef _EDMA3_H_
#define  _EDMA3_H_
#include "defines.h"

#include "tistdtypes.h"

#ifdef EXTERN
#undef EXTERN
#endif //#ifdef EXTERN

#ifdef ALLOC_EDMA_VARIABLES
#undef ALLOC_EDMA_VARIABLES
#define EXTERN

#else  // #ifdef ALLOC_EDMA_VARIABLES
#define EXTERN extern

#endif  // #ifdef ALLOC_EDMA_VARIABLES
#define EDMA_CHANNEL_MAX	(32)
#define EDMA_PaRAM_MAX		(128)




void EdmaEnableChannel(UINT32 channelNumber, UINT32 QueueNumber);
void EdmaDisableChannel(UINT32 channelNumber);

void EdmaInit(void);
//Bool EdmaBlock1D(UINT32 EdmaChannelNo, UINT8 * dest, const UINT8 * src, UINT32 byteCount);
Bool EdmaBlock1D(UINT32 EDMAChannelNo, UINT16* src, UINT16* dest, UINT32 acnt, UINT32 bcnt, UINT32 ndx);
void EdmaClearChannel(UINT32 n);


typedef 
	union{
		UINT32 Register[8];
		struct EDMA_PaRAM
		{

			UINT32 OPT_SAM			:1;
			UINT32 OPT_DAM			:1;
			UINT32 OPT_SYNCDIM		:1;
			UINT32 OPT_STATIC		:1;
			UINT32 OPT_Res3			:4;
			UINT32 OPT_FWID			:3;
			UINT32 OPT_TCCMODE		:1;
			UINT32 OPT_TCC			:6;
			UINT32 OPT_Res2			:2;
			UINT32 OPT_TCINTEN		:1;
			UINT32 OPT_ITCINTEN		:1;
			UINT32 OPT_TCCHEN		:1;
			UINT32 OPT_ITCCHEN		:1;
			UINT32 OPT_PRIVID		:4;
			UINT32 OPT_Res1			:4;

			UINT32 SRC;

			UINT16 ACNT;
			UINT16 BCNT;

			UINT32 DST;

			UINT16 SRCBIDX;
			UINT16 DSTBIDX;

			UINT16 LINK;
			UINT16 BCNTRLD;

			UINT16 SRCCIDX;
			UINT16 DSTCIDX;

			UINT16 CCNT;
			UINT16 Rsvd;

		} Field;
	} PaRAM;


typedef struct EdmaConfigMapTag
{
	UINT32 NUM_DMACH	:3;
	int Res7			:1;
	UINT32 NUM_QDMACH	:3;
	int Res6			:1;
	UINT32 NUM_INTCH	:3;
	int Res5			:1;
	UINT32 NUM_PAENTRY	:3;
	int Res4			:1;
	UINT32 NUM_EVQUE	:3;
	int Res3			:1;
	UINT32 NUM_REGN		:2;
	int Res2			:2;
	UINT32 CHMAP_EXIST	:1;
	UINT32 MP_EXIST		:1;
	int Res1			:6;


} EdmaConfig;


EXTERN PaRAM * EDMA_RAM;

EXTERN int * pEdmaECR;
EXTERN int * pEdmaECRH;
EXTERN int * pEdmaESR;
EXTERN int * pEdmaESRH;
EXTERN int * pEdmaSECR;
EXTERN int * pEdmaSECRH;
EXTERN int * pEdmaIER;
EXTERN int * pEdmaIERH;
EXTERN int * pEdmaIECR;
EXTERN int * pEdmaIECRH;
EXTERN int * pEdmaIESR;
EXTERN int * pEdmaIESRH;
EXTERN int * pEdmaIPR;
EXTERN int * pEdmaIPRH;
EXTERN int * pEdmaICR;
EXTERN int * pEdmaICRH;


#undef EXTERN

#endif  // #ifndef _EDMA3_H_
